<?php

use WSCOMUN\WSComunFClient;

ini_set("soap.wsdl_cache_enabled", 0);

require_once '../../include/WSComunFClient.php';
$keyAutentica 		= WSComunFClient::KEYCLIENTE_AUTENTICA;
$keyAutoriza		= WSComunFClient::KEYCLIENTE_AUTORIZA;
$keyFirma			= WSComunFClient::KEYCLIENTE_FIRMA;
$keyCSV				= WSComunFClient::KEYCLIENTE_CSV;
$keyCatastroBienes	= WSComunFClient::KEYCLIENTE_CATASTRO_BIENES;
$keyCatastro 		= WSComunFClient::KEYCLIENTE_CATASTRO;


/* Array de URIs con los WSDLs descriptivos de cada servicio SAFE disponible */
$v_wsdl = array
(
		$keyAutentica 		=> 'https://preinterint.gva.es/eSirca_Bus/ins/Proxy/SAFE/AutenticacionArangi_v1_00?wsdl',
		$keyAutoriza 		=> 'https://preinterint.gva.es/eSirca_Bus/ins/Proxy/SAFE/AutorizacionHDFI_v1_00?wsdl',
		$keyFirma 			=> 'https://preinterint.gva.es/eSirca_Bus/ins/Proxy/SAFE/FirmaArangi_v1_00?wsdl',
		$keyCSV 			=> 'https://preinterint.gva.es/eSirca_Bus/ins/Proxy/CSV/GVA/CSV_GVA_v1_00?wsdl',
		$keyCatastroBienes 	=> 'https://verificacion-pre.gva.es/pai_bus_ver/CATASTRO/BienesInmuebles_v3_00?wsdl',
		$keyCatastro 		=> 'https://verificacion-pre.gva.es/pai_bus_ver/CATASTRO/ConsultaDatos_v3_00?wsdl'
);

/* Datos del certificado utilizado para las pruebas */
$v_datosCertif = array
(
	'certFile'	=> realpath('../../cert/nopass.crt'),
	'keyFile'	=> realpath('../../cert/nopass.key'),
	'passPhrase'=> null
);

$vTrazabilidad = array
(
	'nsCert'=>	'2bd9adddcd9f0998',
	'idApp'=>	'S4611001A_TEST_00001' // 'S4611001A_INMUEBLES'
);

try
{
	// Comprobaciones
	if (!isset($_REQUEST['id'])) {
		print("Debe indicar el id de la solicitud<br>\n");
		print("Uso: script.php?id=xxx&numElem=yyy&time=zzz");
		die;
	}
	if (!isset($_REQUEST['numElem'])) {
		print("Debe indicar el numero de elementos de la solicitud<br>\n");
		print("Uso: script.php?id=xxx&numElem=yyy&time=zzz");
		die;
	}
	if (!isset($_REQUEST['time'])) {
		print("Debe indicar la marca de tiempo de la solicitud<br>\n");
		print("Uso: script.php?id=xxx&numElem=yyy&time=zzz");
		die;
	}

	// Recoge los parametros de cabecera de la solicitud original
	// Informacion de la peticion (Usar mismos valores que en la solicitud)
	$idPeticion = $_REQUEST['id'];
	$numElementos = $_REQUEST['numElem'];
	$datetime = new DateTime($_REQUEST['time']);


	set_time_limit(200);
	$clienteSIRCA = WSComunFClient::makeWSClient(WSComunFClient::KEYCLIENTE_CATASTRO_BIENES, $v_wsdl, $v_datosCertif);
	$clienteSIRCA->setDebugMode(true);
	$clienteSIRCA->loadTracertPAI($vTrazabilidad);

	$respuestaCAT = null;
	if (false) {
		$respuestaCAT = $clienteSIRCA->catastroBienesRespuesta($idPeticion, $datetime, 'SVDCBIWS02', $numElementos);
	} else {
		$respuestaCAT = $clienteSIRCA->catastroBienesRespuestaB($idPeticion, $datetime, 'SVDCBIWS02', $numElementos);
	}


	$bloqueEstado = $respuestaCAT['respuesta']->Atributos->Estado;
	if ($bloqueEstado->CodigoEstado == '0002') {
		$tsString = $datetime->format(DateTime::ATOM);

		// Informacion de la respuesta
		print("<br>\n<br>\nRespuesta: [{$bloqueEstado->CodigoEstado}] {$bloqueEstado->LiteralError}<br>\n");
		print("Tiempo de espera para la respuesta: {$bloqueEstado->TiempoEstimadoRespuesta}<br>\n");
		print("<a href='test_catastro_bienesSR.php?id=$idPeticion&numElem=$numElementos&time=" . urlencode($tsString) . "'>Volver a solicitar respuesta</a>");
	} else {
		print_r($respuestaCAT);die;
	}
}
catch (Exception $e)
{
//var_dump($e);die;
	print("\n<br/>Error: \n<br/>");
	print($e->getMessage());print("\n<br/>");
	print($e->getTraceAsString());print("\n<br/>");
	print('<pre>');
	$vDebugInfo = is_object($clienteSIRCA)?$clienteSIRCA->getDebugInfo():array('Error en la creacin del objeto WSComunFClient');
	print_r($vDebugInfo);
	print('</pre>');
}

?>