<?php

use WSCOMUN\WSComunFClient;

ini_set("soap.wsdl_cache_enabled", 0);

// Determina si se obtiene el cliente WS mediante el uso del factory (Nuevo metodo)
require_once '../../include/WSComunFClient.php';
$keyGDE2 		= WSComunFClient::KEYCLIENTE_GDE2;

/* Array de URIs con los WSDLs descriptivos de cada servicio SAFE disponible */
$v_wsdl = array
(
		$keyGDE2 => 'https://instrumental-pre.gva.es/pai_bus_ins/GDE/GDEService_v2_00?wsdl'	// Instrumentales
		//$keyGDE2 => 		'https://preinterint.gva.es/eSirca_Bus/ins/Proxy/GDE/GdeWSService_v2_00?wsdl'
);

/* Datos del certificado utilizado para las pruebas */
$v_datosCertif = array
(
	'certFile'	=> realpath('../../cert/SELLO-SCOR-PRE.crt'),
	'keyFile'	=> realpath('../../cert/SELLO-SCOR-PRE.key'),
	'passPhrase'=> null
);

$vTrazabilidad = array
(
	'nsCert'=>	'2039d6a41976eedf',
	'idApp'=>	'WSCOMUN'
);


//Parametros de invocacin generales
$codApp = 'RABA';
$refDoc = 'RABA3cba87cf-4e34-4540-aae3-1a16345a449d';


$vMetaPers = array(
	array(
		'idColeccionMetadatosPersonalizados' => 'P:gde:mezquita_datos_contenido', // 'P:otro:identificable',
		'tipoColeccion' => 'ASPECTO',
		'metadatosPersonalizados' => array(
			array(
				'idMetaDatoPers' => 'gde:mez_u_s_sensibilidad_LOPD', // P:otro:id',
				'tipoMetaDatoPers' => 'CADENA',
				'valorMetaDatoPers' => array( 'A' )	// 0 or more
			)
		)
	),
	// Ejemplo de tipo ESTANDAR
	array(
			'idColeccionMetadatosPersonalizados' => 'DESCONOCIDO',
			'tipoColeccion' => 'ESTANDAR',
			'metadatosPersonalizados' => array(
					array(
							'idMetaDatoPers' => 'AUTOR',
							'tipoMetaDatoPers' => 'CADENA',
							'valorMetaDatoPers' => array( 'PBF' )	// 0 or more
					)
			)
	)
);

try
{
	set_time_limit(40);
	$clienteSIRCA = WSComunFClient::makeWSClient(WSComunFClient::KEYCLIENTE_GDE2, $v_wsdl, array_merge($v_datosCertif, $vTrazabilidad));
	$clienteSIRCA->setDebugMode(true);
	$clienteSIRCA->loadTracertPAI($vTrazabilidad);


	$respuestaGDE2 = $clienteSIRCA->establecerMetadatosPersonalizadosGDE2($codApp, $refDoc, $vMetaPers);

	//var_dump($respuestaGDE2);
	echo "Documento: $refDoc<br>\n";
	echo "MetadatosPersonalizados asociados correctamente: " . ($respuestaGDE2['respuesta']['correcto'] != 'false' ? 'True' : 'False');
}
catch (\WSCOMUN\GDE\GDE2Exception $e)
{
	print("\n<br/>Excepcion GDE2: \n<br/>");
	print("  - CODIGO: " . $e->getCodeAsString());print("\n<br/>");
	print("  - MENSAJE: " . $e->getMessage());print("\n<br/>");
	var_dump($e);
}
catch (Exception $e)
{
	print("\n<br/>Error: \n<br/>");
	print($e->getMessage());print("\n<br/>");
	print('<pre>');
	$vDebugInfo = is_object($clienteSIRCA)?$clienteSIRCA->getDebugInfo():array('Error en la creacin del objeto WSComunFClient');
	print_r($vDebugInfo);
	print('</pre>');
}

?>