<?php

use WSCOMUN\WSComunFClient;

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);
require_once '../../../include/WSComunFClient.php';
$keyGDE2 = WSComunFClient::KEYCLIENTE_GDE2;

/* Array de URIs con los WSDLs descriptivos de cada servicio SAFE disponible */
$v_wsdl = array
(
		$keyGDE2 => 'https://innovacion-pre.gva.es/pai_bus_inno/GDE/GDEService_v2_00?wsdl'	// Instrumentales
);

/* Datos del certificado utilizado para las pruebas */
$v_opciones = array
(
		//'certFile'	=> realpath('../../../cert/SELLO-SCOR-PRE.crt'),
		//'keyFile'	=> realpath('../../../cert/SELLO-SCOR-PRE.key'),
		'passPhrase' 			=> null,
		'enableWSSecurity' 		=> false, //Innovacion
		'enableTrazabilidadPAI' => true,
		'idApp' 				=> 'WSCOMUN',
);


//Parametros de invocacin generales
$codApp = 'RABA';
$path = '2015_v2_test_soapUI_eliminar';
$metadatosExpedienteEni = array(
		'versionNTI' => 'http://administracionelectronica.gob.es/ENI/XSD/v1.0/documento-e',
		'organo' => array( 'A10000PRE' ),	 // 1 or more
		'identificador' => 'ES_A10000PRE_2013_EXP_000000000000000000000001183638',
		'fechaAperturaExpediente' => new DateTime('2015-05-20T11:29:38.468+02:00'),
		'estado' => 'E01',
		'clasificacion' => 'CLASIFICACION',
		'interesado' => array( 'lmhubeda' ) // 1 or more
);
$coleccionMetadatosPersonalizados = array(
	array(
		'idColeccionMetadatosPersonalizados' => 'gde:incorporable',
		'tipoColeccion' => 'ASPECTO',
		'metadatosPersonalizados' => array(
			array(
				'idMetaDatoPers' => 'gde:eni_u_t_fecha_incorporacion_expediente',
				'tipoMetaDatoPers' => 'FECHA',
				'valorMetaDatoPers' => array( new DateTime('2015-05-20T11:29:38.468+02:00') )
			)
		)
	)
);


print("\n\n<br><br><br>Prueba de GDE2: crearCarpetaGDE2($codApp, $path)<br>\n");

try
{
	set_time_limit(40);
	$clienteSIRCA = WSComunFClient::makeWSClient($keyGDE2, $v_wsdl, $v_opciones);
	$clienteSIRCA->setDebugMode(true);


	$respuestaGDE2 = $clienteSIRCA->crearCarpetaGDE2($codApp, $path, null, $metadatosExpedienteEni, $coleccionMetadatosPersonalizados);

	echo "Carpeta '" . $path . "' creada correctamente: " . ($respuestaGDE2['correcto'] ? "True" : "False");
}
catch (Exception $e)
{
	print("\n<br/>Error: \n<br/>");
	print($e->getMessage());print("\n<br/>");
	print('<pre>');
	$vDebugInfo = is_object($clienteSIRCA)?$clienteSIRCA->getDebugInfo():array('Error en la creacin del objeto WSComunFClient');
	print_r($vDebugInfo);
	print('</pre>');
}

?>