<?php

use WSCOMUN\WSComunFClient;

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);
require_once '../../../include/WSComunFClient.php';
$keyGDE2 = WSComunFClient::KEYCLIENTE_GDE2;

/* Array de URIs con los WSDLs descriptivos de cada servicio SAFE disponible */
$v_wsdl = array
(
		$keyGDE2 => 'https://innovacion-pre.gva.es/pai_bus_inno/GDE/GDEService_v2_00?wsdl'	// Instrumentales
);

/* Datos del certificado utilizado para las pruebas */
$v_opciones = array
(
		//'certFile'	=> realpath('../../../cert/SELLO-SCOR-PRE.crt'),
		//'keyFile'	=> realpath('../../../cert/SELLO-SCOR-PRE.key'),
		'passPhrase' 			=> null,
		'enableWSSecurity' 		=> false, //Innovacion
		'enableTrazabilidadPAI' => true,
		'idApp' 				=> 'WSCOMUN',
);


//Parametros de invocacin generales
$codApp = 'RABA';


$contenidoDOCENI = file_get_contents('docENI_NLZ.xml');

$nombreDoc = 'prueba.eni';
$metaPers = array(
		array(
				'idColeccionMetadatosPersonalizados' => 'P:gde:mezquita_datos_contenido',
				'tipoColeccion' => 'ASPECTO',
				'metadatosPersonalizados' => array(
						array(
								'idMetaDatoPers' => 'gde:mez_u_s_sensibilidad_LOPD',
								'tipoMetaDatoPers' => 'CADENA',
								'valorMetaDatoPers' => array( 'A' )
						)
				)
		)
);



print("\n\n<br><br><br>Prueba de GDE: insertarDocumentoENIGDE2($codApp, CONTENIDODOCENI, $nombreDoc)<br>\n<br>\n");
try
{
	set_time_limit(40);
	$clienteSIRCA = WSComunFClient::makeWSClient($keyGDE2, $v_wsdl, $v_opciones);
	$clienteSIRCA->setDebugMode(true);

	$respuestaGDE = $clienteSIRCA->insertarDocumentoENIGDE2($codApp, $contenidoDOCENI, $nombreDoc, null, null, null, $metaPers, null);

//	var_dump($respuestaGDE);
	echo ("Referencia Documento: " . $respuestaGDE['referenciaDocumento'] . "<br>\n");
	echo ("Nombre documento: " . $respuestaGDE['nombre'] . "<br>\n");
}
catch (Exception $e)
{
	print("\n<br/>Error: \n<br/>");
	print($e->getMessage());print("\n<br/>");
	print($e->getTraceAsString());print("\n<br/>");
	print('<pre>');
	print('<pre>');
	$vDebugInfo = is_object($clienteSIRCA)?$clienteSIRCA->getDebugInfo():array('Error en la creacin del objeto WSComunFClient');
	print_r($vDebugInfo);
	print($e->getMessage());
	print('</pre>');
};

?>