<?php

use WSCOMUN\WSComunFClient;

use WSCOMUN\REGDEPARTAMENTAL\DocumentoIdentificativoType;
use WSCOMUN\REGDEPARTAMENTAL\DatosDomicilioType;
use WSCOMUN\REGDEPARTAMENTAL\DatosIdentificativosType;
use WSCOMUN\REGDEPARTAMENTAL\DestinosType;
use WSCOMUN\REGDEPARTAMENTAL\DatosRegistroType;
use WSCOMUN\REGDEPARTAMENTAL\DatosExpedienteType;
use WSCOMUN\REGDEPARTAMENTAL\DocumentoType;
use WSCOMUN\REGDEPARTAMENTAL\DocumentosType;

//error_reporting(E_ERROR | E_WARNING | E_PARSE);
error_reporting(E_ALL);
ini_set('display_errors', 1);

ini_set("soap.wsdl_cache_enabled", 0);

require_once '../../../include/WSComunFClient.php';

$keyRD 		= WSComunFClient::KEYCLIENTE_REGDEPARTAMENTAL;


/* Array de URIs con los WSDLs descriptivos de cada servicio SAFE disponible */
$v_wsdl = array
(
		$keyRD => 'https://innovacion-pre.gva.es/pai_bus_inno/RD/RegistroDepartamentalService_v1_00?wsdl'
);


$vTrazabilidad = array
(
		'idApp'=>	'WSCOMUN'			//WSCOMUN
);


try
{
	// Creacin del cliente
	set_time_limit(40);
	$clienteWS = WSComunFClient::makeWSClient(WSComunFClient::KEYCLIENTE_REGDEPARTAMENTAL, $v_wsdl, $vTrazabilidad);
	$clienteWS->setDebugMode(true);

	$contenidoBase64 = 'RXN0ZSBlcyBlbCB0ZXh0byBkZSBwcnVlYmEgJiB2ZXJpZmljYWNpw7Nu';

	// Composicion de los objetos de la peticion
	$codigoOrganismoUnidadDepartamental = '02';
	$codigoUnidadDepartamental = 'ORVE1';
	$tipoRegistroDepartamental = 'S';
	$codigoAsuntoHabitual = null; // 'AS00';
	$asunto = 'Este Asunto';
	$observacionesDepartamentales = 'AAAA';
	$observacionesGenerales = 'BBBB';

	$intDocIdentificativo = new DocumentoIdentificativoType();
	$intDocIdentificativo->setTipoDocumentoIdentificativo('1');
	$intDocIdentificativo->setNumeroDocumentoIdentificativo('20009672V');

	$intDatosDomicilio = new DatosDomicilioType();
	$intDatosDomicilio->setDireccion('miDireccion');
	$intDatosDomicilio->setCodigoPostal('46750');
	$intDatosDomicilio->setCodigoProvincia('46');
	$intDatosDomicilio->setCodigoMunicipio('250');
	$intDatosDomicilio->setDescripcionMunicipio('Simat de la Valldigna');
	$intDatosDomicilio->setCodigoPoblacion('11');
	$intDatosDomicilio->setPais( utf8_encode('Espaa') );
	$intDatosDomicilio->setTelefono('660786092');
	$intDatosDomicilio->setFax('96281000');


	$datosIdentificativos = new DatosIdentificativosType();
	//$datosIdentificativos->setNombreApellidos('Jose Castillo Soler');
	$datosIdentificativos->setNombre('Jose');
	$datosIdentificativos->setApellido1('Castillo');
	$datosIdentificativos->setApellido2('Soler');

	$datosIdentificativos->setDocumentoIdentificativo($intDocIdentificativo);
	$datosIdentificativos->setDomicilio($intDatosDomicilio);

	$destinos = new DestinosType();
	$destinos->addDestino('14SGENE');
	$destinos->addDestino('14SGENE');

	$datosRegistroGeneralSalida = new DatosRegistroType();
	$datosRegistroGeneralSalida->setOrganismo('04');
	$datosRegistroGeneralSalida->setUnidadRegistral('TTE');
	$datosRegistroGeneralSalida->setAnyo('2017');
	$datosRegistroGeneralSalida->setNumeroRegistro(1);
	$datosRegistroGeneralSalida = null;

	/*
	$otraUnidadDeProcedencia = 'UDEP';
	$descripcionOtraUnidadDeProcedencia = 'MiOtraUnidadDeProcedencia';
	*/
	$otraUnidadDeProcedencia = null;
	$descripcionOtraUnidadDeProcedencia = null;

	/*
    $datosRegistroDepartamentalOrigen = new IdentificacionRegistroDepartamentalType();
    $datosRegistroDepartamentalOrigen->setOrganismo('04');
    $datosRegistroDepartamentalOrigen->setCodigoUnidadDepartamental('UDEP');
    $datosRegistroDepartamentalOrigen->setAnyo('2018');
    $datosRegistroDepartamentalOrigen->setNumeroRegistro(1);
    $datosRegistroDepartamentalOrigen->setTipoRegistroDepartamental('E');
    */
    $datosRegistroDepartamentalOrigen = null;


	$tipoTransporte = 'V';

	$datosExpediente = new DatosExpedienteType();
	//$datosExpediente->setMaquina('F');
	//$datosExpediente->setNumeroReset('10');
	$datosExpediente->setCodigoExpediente('ESTE');


    $intDocumento = new DocumentoType();
  	//$intDocumento->setCodigoNormalizadoDocumento('C001'); //en el ejemplo no sale estavariable
    $intDocumento->setDescripcionDocumento('Documento de prueba');
    $intDocumento->setNombreDocumento('Prueba_doc.txt');
    $intDocumento->setFechaDocumento('20111111');
    $intDocumento->setContenido( $contenidoBase64 );
    $intDocumento->setHash( sha1($contenidoBase64) );

    $documentos = new DocumentosType();
	$documentos->addDocumento($intDocumento);

	// Consulta al WS
	$oRespWS = $clienteWS->creacionRegistroDepartamental($codigoOrganismoUnidadDepartamental, $codigoUnidadDepartamental,
	    $tipoRegistroDepartamental, $codigoAsuntoHabitual, $asunto, $observacionesDepartamentales,
	    $observacionesGenerales, $datosIdentificativos, $destinos, $datosRegistroGeneralSalida,
	    $otraUnidadDeProcedencia, $descripcionOtraUnidadDeProcedencia, $datosRegistroDepartamentalOrigen,
	    $tipoTransporte, $datosExpediente, $documentos);


	// Muestra los resultados
	echo("Resultado: " . $oRespWS->getResultado() . "<br>\r\n");

	echo("Registros creados: <br>\r\n");
	if ($oRespWS->hasRegistrosCreados()) {
		$oRegs = $oRespWS->getRegistrosCreados();
		if ($oRegs->hasRegistroCreado()) {
			for ($iReg=0; $iReg < $oRegs->countRegistroCreado(); $iReg++) {
				$oReg = $oRegs->getRegistroCreado($iReg);

				echo "&nbsp;- Registro $iReg: " . $oReg->getCodigoRegistro() . " | " . $oReg->getFechaRegistro() . "<br>\r\n";
				echo "&nbsp;--- Resultado: " . $oReg->getResultado() . "<br>\r\n";
				echo "&nbsp;--- Destino: " . $oReg->getDestino() . "<br><br>\r\n\r\n";
			}
		}
	}
	echo("<br>\r\n\r\n");

	echo('<pre>');print_r($oRespWS);echo('</pre>');

}
catch (\WSCOMUN\WSComunPAIException $e)
{
	print("\n<br/>Excepcion PAI: \n<br/>");
	print("  - ERROR: " . $e);print("\n<br/>");
	print("  - CODIGO: " . $e->getCode());print("\n<br/>");
	print("  - MENSAJE: " . $e->getMessage());print("\n<br/>");

	var_dump($e);
}
catch (Exception $e)
{
	print("\n<br/>Error: \n<br/>");
	print($e->getMessage());print("\n<br/>");
	print('<pre>');
	$vDebugInfo = $clienteWS->getDebugInfo();
	print_r($vDebugInfo);
	print('</pre>');
}


?>