<?php

use WSCOMUN\WSComunFClient;
use WSCOMUN\PORTAFIRMAS\signer;
use WSCOMUN\PORTAFIRMAS\signerList;
use WSCOMUN\PORTAFIRMAS\user;

error_reporting(E_ERROR | E_WARNING | E_PARSE);

ini_set("soap.wsdl_cache_enabled", 0);

require_once '../../include/WSComunFClient.php';
$keyPF 		= WSComunFClient::KEYCLIENTE_PF;
$keyPFMOD	= WSComunFClient::KEYCLIENTE_PF_MOD;
$keyPFADM	= WSComunFClient::KEYCLIENTE_PF_ADM;

require_once 'libOpts.php';


/*
 * El script comprueba las funciones de manipulacin de firmantes
 *
 * Uso: test_pf_testSignersOps.php?requestId=xxxxxxx"
 *
 * Incluye llamadas a las siguiente funciones:
 * 	- insertSigners
 * 	- deleteSigners
 */


/* Array de URIs con los WSDLs descriptivos de cada servicio SAFE disponible */
$v_wsdl = array
(
	$keyPF			=> 'https://instrumental-pre.gva.es/pai_bus_ins/PORTAFIRMAS/QueryService_v2_00?wsdl',
	$keyPFMOD		=> 'https://instrumental-pre.gva.es/pai_bus_ins/PORTAFIRMAS/ModifyService_v2_00?wsdl',
	$keyPFADM		=> 'https://instrumental-pre.gva.es/pai_bus_ins/PORTAFIRMAS/AdminService_v2_00?wsdl'
);

/* Datos del certificado utilizado para las pruebas */
$v_datosCertif = array
(
	'certFile'	=> realpath('../../cert/SELLO-SCOR-PRE.crt'),
	'keyFile'	=> realpath('../../cert/SELLO-SCOR-PRE.key'),
	'passPhrase'=> null
);

$vTrazabilidad = array
(
	'nsCert'=>	'2039d6a41976eedf',
	'idApp'=>	'WSCOMUN'
);


$username = 'WSCOMUN';
$password = 'WSC4M5N';



// Informacion de uso
if (!isset($_REQUEST['requestId'])) {
	print("Debe indicar el id del request a buscar<br>\n");
	print("Uso: script.php?requestId=xxxxxxx");
	die;
}

$requestId = $_REQUEST['requestId'];

print("requestId a consultar: $requestId<br>\n");



try
{
	set_time_limit(40);
	$clienteSIRCA = WSComunFClient::makeWSClient(WSComunFClient::KEYCLIENTE_PF, $v_wsdl, array_merge($v_datosCertif, $vTrazabilidad));
	$clienteSIRCA->setDebugMode(true);
	$clienteSIRCA->loadTracertPAI($vTrazabilidad);



	// pf_mod_insertSigners
	$idUser = 'CARGO 1 PRUEBAS WSCOMUN';
	$signerUserJob = new user();
	$signerUserJob->setIdentifier($idUser);
	$signer = new signer();
	$signer->setUserJob($signerUserJob);

	$idUser2 = '29200530Y';
	$signerUserJob2 = new user();
	$signerUserJob2->setIdentifier($idUser2);
	$signer2 = new signer();
	$signer2->setUserJob($signerUserJob2);

	$signerList = new signerList();
	$signerList->addSigner($signer);
	$signerList->addSigner($signer2);

	$respuesta = $clienteSIRCA->pf_mod_insertSigners($username, $password, $requestId, 1, $signerList, 'VISTOBUENO');
	printf("Usuario '%s' aadido como firmante a la peticin '%s', <br>\n", $idUser, $respuesta['requestId']);
	printf("Usuario '%s' aadido como firmante a la peticin '%s', <br>\n", $idUser2, $respuesta['requestId']);
	//	print_r($respuesta);



	// pf_mod_deleteSigners
	$signerListDelete = new signerList();
	$signerListDelete->addSigner($signer);

	$respuesta = $clienteSIRCA->pf_mod_deleteSigners($username, $password, $requestId, $signerListDelete);
	printf("<br>\nUsuario '%s' eliminado como firmante de la peticin '%s', <br>\n", $idUser, $respuesta['requestId']);
//	print_r($respuesta);

}
catch (Exception $e)
{
	print("\n<br/>Error: \n<br/>");
	print($e->getMessage());print("\n<br/>");
	print('<pre>');
	$vDebugInfo = is_object($clienteSIRCA)?$clienteSIRCA->getDebugInfo():array('Error en la creacin del objeto WSComunFClient');
	print_r($vDebugInfo);
	print('</pre>');
}

// Muestra los enlaces a otras funcionalidades
showLinks($requestId);

?>