<?php

use WSCOMUN\WSComunFClient;
use WSCOMUN\PORTAFIRMAS\importanceLevel;
use WSCOMUN\PORTAFIRMAS\remitterList;
use WSCOMUN\PORTAFIRMAS\request;
use WSCOMUN\PORTAFIRMAS\signLine;
use WSCOMUN\PORTAFIRMAS\signLineList;
use WSCOMUN\PORTAFIRMAS\signer;
use WSCOMUN\PORTAFIRMAS\signerList;
use WSCOMUN\PORTAFIRMAS\user;

error_reporting(E_ERROR | E_WARNING | E_PARSE);

ini_set("soap.wsdl_cache_enabled", 0);

require_once '../../include/WSComunFClient.php';
$keyPF 		= WSComunFClient::KEYCLIENTE_PF;
$keyPFMOD	= WSComunFClient::KEYCLIENTE_PF_MOD;
$keyPFADM	= WSComunFClient::KEYCLIENTE_PF_ADM;

require_once 'libOpts.php';


/*
 * El script comprueba las funciones de modificacin de peticiones
 *
 * Uso: test_pf_testSignersOps.php?requestId=xxxxxxx"
 *
 * Incluye llamadas a las siguiente funciones:
 * 	- updateRequest
 * 	- queryRequest
 */


/* Array de URIs con los WSDLs descriptivos de cada servicio SAFE disponible */
$v_wsdl = array
(
	$keyPF			=> 'https://instrumental-pre.gva.es/pai_bus_ins/PORTAFIRMAS/QueryService_v2_00?wsdl',
	$keyPFMOD		=> 'https://instrumental-pre.gva.es/pai_bus_ins/PORTAFIRMAS/ModifyService_v2_00?wsdl',
	$keyPFADM		=> 'https://instrumental-pre.gva.es/pai_bus_ins/PORTAFIRMAS/AdminService_v2_00?wsdl'
);

/* Datos del certificado utilizado para las pruebas */
$v_datosCertif = array
(
	'certFile'	=> realpath('../../cert/SELLO-SCOR-PRE.crt'),
	'keyFile'	=> realpath('../../cert/SELLO-SCOR-PRE.key'),
	'passPhrase'=> null
);

$vTrazabilidad = array
(
	'nsCert'=>	'2039d6a41976eedf',
	'idApp'=>	'WSCOMUN'
);


$username = 'WSCOMUN';
$password = 'WSC4M5N';



// Informacion de uso
if (!isset($_REQUEST['requestId'])) {
	print("Debe indicar el id del request a buscar<br>\n");
	print("Uso: script.php?requestId=xxxxxxx");
	die;
}

$requestId = $_REQUEST['requestId'];

print("requestId introducido: $requestId<br>\n");



try
{
	$clienteSIRCA = WSComunFClient::makeWSClient(WSComunFClient::KEYCLIENTE_PF, $v_wsdl, array_merge($v_datosCertif, $vTrazabilidad));
	$clienteSIRCA->setDebugMode(true);
	$clienteSIRCA->loadTracertPAI($vTrazabilidad);


//error_reporting(E_ALL);
//ini_set('display_errors', 1);

	// pf_mod_createRequest
	$request = new request();
	$request->setIdentifier($requestId);
	$request->setSubject("PruebaNEW");
	$request->setFentry(new DateTime());
	$request->setFstart(new DateTime());
	$request->setFexpiration((new DateTime())->modify('2 hour'));
	$request->setReference('Referencia OpcionalNEW');
	$request->setText('contenido del mensajeNEW');
	$request->setSignType('CASCADA');
	$request->setApplication('WSCOMUN');


	$impLvl = new importanceLevel();
	$impLvl->setLevelCode(2);
	$impLvl->setDescription('Alta');
	$request->setImportanceLevel($impLvl);

	/*
	$docType = new documentType();
	$docType->setIdentifier('INFORME');
	$docType->setDescription('Informe generico');
	$docType->setValid(true);

	$doc = new document();
	$doc->setIdentifier('12345678');
	$doc->setName('documento de prueba.pdf');
	$doc->setMime('application/pdf');
	$doc->setDocumentType($docType);
	$doc->setContent('content');	// BASE64
	//$doc->setType($value);
	//$doc->setUri($value);
	$doc->setSign(true);

	$docList = new documentList();
	$docList->addDocument($doc);

	$request->setDocumentList($docList);
	*/

	$signerUserJob = new user();
	$signerUserJob->setIdentifier('WSCOMUN');
	$signer = new signer();
	$signer->setUserJob($signerUserJob);
	$signerList = new signerList();
	$signerList->addSigner($signer);
	$signLine = new signLine();
	$signLine->setSignerList($signerList);
	$signLine->setType('FIRMA');
	$signLineList = new signLineList();
	$signLineList->addSignLine($signLine);
	$request->setSignLineList($signLineList);

	$userRemitter = new user();
	$userRemitter->setIdentifier('WSCOMUN');
	$remitterList = new remitterList();
	$remitterList->addUser($userRemitter);
	$request->setRemitterList($remitterList);

	//$request->setParameterList($value);
	//$request->setNoticeList($value);
	//$request->setActionList($value);
	//$request->setCommentList($value);
	$request->setRequestStatus('ACEPTADO');


	// pf_mod_updateRequest
	$respuesta = $clienteSIRCA->pf_mod_updateRequest($username, $password, $request);
	print("<br>\nrequestId modificado: {$respuesta['requestId']}<br>\n");
	print_r($respuesta);



	// pf_queryRequest
	$respuesta = $clienteSIRCA->pf_queryRequest($username, $password, $requestId);
	print("<br>\nInformacion basica de la solicitud:<br>\n");
	print("- Subject: {$respuesta['request']['subject']}<br>\n");
	print("- Reference: {$respuesta['request']['reference']}<br>\n");
	print("- Text: {$respuesta['request']['text']}<br>\n");
	print("- 1er Documento: {$respuesta['request']['documentList']['document']['identifier']}<br>\n");
	echo('<pre>');print_r($respuesta);echo('</pre>');

}
catch (Exception $e)
{
	print("\n<br/>Error: \n<br/>");
	print($e->getMessage());print("\n<br/>");
	print('<pre>');
	$vDebugInfo = is_object($clienteSIRCA)?$clienteSIRCA->getDebugInfo():array('Error en la creacin del objeto WSComunFClient');
	print_r($vDebugInfo);
	print('</pre>');
}

// Muestra los enlaces a otras funcionalidades
showLinks($requestId);

?>